import java.util.*;
/**
 * Write a description of class Factura here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Factura
{
    // instance variables - replace the example below with your own
    private Date fecha;
    private int numero;
    private double monto;
    private boolean confirmada=false;
    private boolean pagada=false;
    private Cliente cli = null;
    private List<Detalle> detalle = new ArrayList<Detalle>();

    /**
     * Constructor for objects of class Factura
     */
    public Factura()
    {
        // initialise instance variables
        this(0);
    }
    public Factura(int n) {
        this(n,new Date());
    }
    public Factura(int n,Date f) {
        this(n,f,null);
    }
    public Factura(int n,Date f,Cliente c) {
        this(n,f,c,0.0);
    }
    public Factura(int n,Date f,Cliente c,double m) {
        this(n,f,c,m,false);
    }
    public Factura(int n,Date f,Cliente c,double m,boolean conf) {
        this(n,f,c,m,conf,false);
    }
    public Factura(int n,Date f,Cliente c,double m,boolean conf,boolean pag) {
        setNumero(n);setFecha(f);setCliente(c);setMonto(m);confirmada=conf;pagada=pag;
    }

    // setters
    public void setNumero(int n) { if ( !isConfirmada() ) numero=n; }
    private void setMonto(double m) { if ( !isConfirmada() ) monto=m; }
    public void setFecha(Date f) { 
        if ( !isConfirmada() ) {
            if ( f == null ) {
                Date d = new Date();
                d.setTime(System.currentTimeMillis());
                fecha=d;
            } else {
                Date dd = new Date();
                if ( dd.getTime() == f.getTime() ) {
                    f.setTime(System.currentTimeMillis());
                }
                fecha=f; 
            }
        }
    }
    public void setCliente(Cliente d) { if ( !isConfirmada() ) cli=d; }
    // getters
    public boolean isConfirmada() { return confirmada; }
    public boolean isPagada() { return pagada; }
    public int getNumero() { return numero; }
    public double getMonto() { return monto; }
    public Date getFecha() { return fecha; }
    public Cliente getCliente() { return cli; }
    // custom
    public void addDetalle(Detalle d) { if ( !isConfirmada() ) detalle.add(d); }
    public void confirmar() {
        calcular();
        // descontar stock
        // sumar saldo deudor del cliente
        // no se puede modificar
        confirmada=true;
    }
    public void calcular() {
        // calcula el monto de la factura a partir de las lineas de detalle
        double total=0.0;
        /*  FORMA DE ITERACION SIMPLE
        for(Detalle d : detalle) {
            System.out.println("calcular(): Sumo Detalle cantidad:"+d.getCantidad()+" precio:"+d.getPrecio());
            total+=d.getSubTotal();
        }
        */
        /* ITERACION utilizanzo Iterator
        Iterator<Detalle> i = detalle.iterator();
        while(i.hasNext()) {
            Detalle d = i.next();
            System.out.println("calcular(): Sumo Detalle cantidad:"+d.getCantidad()+" precio:"+d.getPrecio());
            total+=d.getSubTotal();
        }
        */
        //ITERACION utilizando metodos de la Interface List get() y metodo de la interface Collection size()
        for(int i=0;i<detalle.size();i++) {
            Detalle d = detalle.get(i);
            System.out.println("calcular(): Sumo Detalle cantidad:"+d.getCantidad()+" precio:"+d.getPrecio());
            total+=d.getSubTotal();
        }
        setMonto(total);
    }
    public void pagar() {
        if ( isConfirmada() && !isPagada()) {
            // restaba saldo deudor del cliente
            pagada=true;
        }
    }
    
    /**
     * Sobre escribe metodo toString para devolver en string todos sus campos correspondientes a cliente
     * @return String datos de cliente
     */
    @Override
    public String toString(){
        //return ">Idc : "+getIdc()+" >Descripcion : "+getDescripcion()+" >Saldo : "+getSaldo();
        return ""+getNumero()+" $"+getMonto();
    }
    
    /**
     * Código que añadimos a la clase Cliente. Sobreescritura del método equals
     * @return true or false
     */
    @Override
    public boolean equals (Object obj) {
        if (obj == null){return false;}
        if (obj == this){return true; }
        else if ( (obj instanceof Factura) && (((Factura)obj).getNumero() == this.getNumero()) ) {
            return true;
        } else {return false; }
    }
    
    /**
     * Si el metodo hascode es invocado en multiples ocaciones durante la ejecucion de una aplicacion, este debe
     * regresar consistentemente el mismo valor entero.
     * Si dos objetos son iguales segun el  metodo equals entonces la llamada al metodo hash code debe regresar el
     * mismo hashcode.
     * 
     * El métodohashCode() de Cliente debe retornar el atributo idc
     * 
     */
    @Override
    public int hashCode(){
        return getNumero();
    }
    
}
